#ifndef MY_CONVEX_HULL_H
#define MY_CONVEX_HULL_H

#include "../share/common.h"
#include "../share/WildMagic.h"

class MyConvexHull
{
    Vector2d*     pts;
    int           nr_p;
    int           nr_v;
public:
    enum Method {INCREMENTAL, DEVIDE_AND_CONQUER};
	MyConvexHull(Vector2d* pts_, int nr_p_, Method = INCREMENTAL);

	Vector2d  pt(int idx) const {return pts[idx - 1];}
	Vector2d& pt(int idx)       {return pts[idx - 1];}

    virtual void setNoPoints  (int nr_p_) {nr_p = nr_p_;}
	virtual int  getNoPoints  () const {return nr_p;}
    virtual void setNoVerteces(int nr_v_) {nr_v = nr_v_;}
    virtual int  getNoVerteces() const {return nr_v;}

    virtual double getConvexHullArea() const;
    virtual ~MyConvexHull(){}
};

#endif
