#include "blg.h"

Blg& Blg::operator=(Blg blg_)
{
	tetra = blg_.tetra;
	Tetra = blg_.Tetra;
	h_b   = blg_.h_b; c_l = blg_.c_l;
	return *this;
}

Blg::Blg()
{
	h_b = 0;
	c_l = 0;
}

void Blg::scan(ifstream& is)
{
	ML_TRACE("Blg::scan");

	double p_x, p_y, q_x, q_y, w_w, h_h; int seq;

	is >> seq; is.ignore(NO_OF_CHARS_PER_ONE_LINE, ',');
	is >> p_x; is.ignore(NO_OF_CHARS_PER_ONE_LINE, ',');
	is >> p_y; is.ignore(NO_OF_CHARS_PER_ONE_LINE, ',');
	is >> q_x; is.ignore(NO_OF_CHARS_PER_ONE_LINE, ',');
	is >> q_y; is.ignore(NO_OF_CHARS_PER_ONE_LINE, ',');
	is >> w_w; is.ignore(NO_OF_CHARS_PER_ONE_LINE, ',');
	is >> h_h; h_b = h_h;

	Vector2d p_1 = Vector2d(p_x, p_y);
	Vector2d p_2 = Vector2d(q_x, q_y);

	const double l_l = (p_2 - p_1).Length();

	// Setting dummy values in case of no building application.
	if(l_l < 1.0e-6 || w_w  < 1.0e-6 || h_h < 1.0e-6)
	{
		p_1 = Vector2d(0.0, 0.0);
		p_2 = Vector2d(0.0, 0.1);
		w_w = 0.1;
		h_h = 0.0;
	}

	const Vector2d eg1 = (p_2 - p_1)/(p_2 - p_1).Length();
	const Vector2d eg2 = Vector2d(-eg1.Y(), eg1.X());

	tetra.pt(1) = p_1;
	tetra.pt(2) = p_2;
	tetra.pt(3) = p_2 + eg2*w_w;
	tetra.pt(4) = p_1 + eg2*w_w;




	/*
	tetra.pt(1) = Vector2d(floor(p_1.X() + 0.5), floor(p_1.Y() + 0.5));
	tetra.pt(2) = Vector2d(floor(p_2.X() + 0.5), floor(p_2.Y() + 0.5));
	tetra.pt(3) = Vector2d(floor(p_2.X() + eg2.X()*w_w + 0.5), floor(p_2.Y() + eg2.Y()*w_w + 0.5));
	tetra.pt(4) = Vector2d(floor(p_1.X() + eg2.X()*w_w + 0.5), floor(p_1.Y() + eg2.Y()*w_w + 0.5));
	*/
}
