#include "rectify.h"

void Rectify::exec()
{
	ML_TRACE("Rectify::exec");

	Vector2d ctr = Vector2d::ZERO;
	for(int i = 1; i <= hll->getNoVerteces(); i++)
	{
		ctr += hll->pt(i);
	}
	ctr = ctr/hll->getNoVerteces();



	int idx1, idx2, j;
	double max1 = 0; Vector2d dia1 = Vector2d::ZERO;
	for(j = 1; j <=  hll->getNoVerteces(); j++)
	{
		const double dist = (hll->pt(j) - ctr).Length();

		if(dist > max1)
		{
			max1 = dist;
			dia1 = hll->pt(j);
			idx1 = j;
		}
	}
	const Vector2d Dia1 = (dia1 - ctr)/(dia1 - ctr).Length();


	double max2 = 0; Vector2d dia2 = Vector2d::ZERO; bool pass = false;
	for(j = 1; j <=  hll->getNoVerteces(); j++)
	{
		const double   dist = (hll->pt(j) - ctr).Length();

		if(dist > max2 && j != idx1)
		{
			max2 = dist;
			dia2 = hll->pt(j);
			idx2 = j;
			pass = true;
		}
	}
	if(!pass)
	{
		cout << "<Rectify::exec> Wrong cluster! Stop further evaluation." << endl;
		CERR << "<Rectify::exec> Wrong cluster! Stop further evaluation." << endl;
		exit(1);
	}
	Vector2d Dia2 = (dia2 - ctr)/(dia2 - ctr).Length();


	double min1 = 1.0e10; Vector2d dia3 = Vector2d::ZERO; pass = false;
	for(j = 1; j <=  hll->getNoVerteces(); j++)
	{
		const double   dist = (hll->pt(j) - ctr).Length();

		if(dist < min1 && j != idx1 && j != idx2)
		{
			min1 = dist;
			dia3 = hll->pt(j);
			pass = true;
		}
	}
	if(!pass)
	{
		cout << "<Rectify::exec> Wrong cluster! Stop further evaluation." << endl;
		CERR << "<Rectify::exec> Wrong cluster! Stop further evaluation." << endl;
		exit(1);
	}
	Vector2d Dia3 = (dia3 - ctr)/(dia3 - ctr).Length();


	// Choosing wider angle direction created with Dia1 (For avoiding too narrow rectangle).
	Dia2 = (fabs(Dia1.Dot(Dia2)) < fabs(Dia1.Dot(Dia3)) ? Dia2 : Dia3);


	const double magnify = sqrt(hll->getConvexHullArea()/(fabs(Dia1.X()*Dia2.Y() - Dia2.X()*Dia1.Y())*2));
	// cout << "magnify=" << magnify << endl;
	ttr.pt(1) = ctr + magnify*Dia1;
	ttr.pt(2) = ctr + magnify*Dia2;
	ttr.pt(3) = ctr - magnify*Dia1;
	ttr.pt(4) = ctr - magnify*Dia2;

	/*
	cout << "Rect" << endl;
	cout << ttr.pt(1).X() << ',' << ttr.pt(1).Y() << endl;
	cout << ttr.pt(2).X() << ',' << ttr.pt(2).Y() << endl;
	cout << ttr.pt(3).X() << ',' << ttr.pt(3).Y() << endl;
	cout << ttr.pt(4).X() << ',' << ttr.pt(4).Y() << endl;
	*/
}
