#ifndef ERROR_HANDLER_H
#define ERROR_HANDLER_H

#include "../share/common.h"

// Prototype declaration(s)
class ErrorHandler;


// Define global function(s) for binary operators
ostream& operator<<(ostream&  os, const ErrorHandler& e);
ostream& operator<<(ofstream& os, const ErrorHandler& e);


// Definition(s) of interface class(es)
class ErrorHandler
{
public:
	virtual string message() const = 0;
	virtual ~ErrorHandler(){}
};




// Definition(s) of concrete class(es)

class ErrorMetData_scan : public ErrorHandler
{
	string str;
public:
	ErrorMetData_scan(string str_){str = str_;}
	virtual string message() const;
};

class ErrorMetData_scan_dl : public ErrorHandler
{
	string str;
	double dyl;
public:
	ErrorMetData_scan_dl(string str_, double dyl_){str = str_; dyl = dyl_;}
	virtual string message() const;
};

class ErrorTimeCode_scan : public ErrorHandler
{
	string str;
public:
	ErrorTimeCode_scan(string str_){str = str_;}
	virtual string message() const;
};

#endif
