#ifndef MET_DATA_H
#define MET_DATA_H

#include "../share/SimpleIterator.h"
#include "../share/FileFactory.h"

class MetData : public SimpleIterator, public FileManager
{
protected:
	double lon;		// Longitude
	double lat;		// Latitude
	double zzz;		// Height of anemometer (meters)
	int    tzn;		// Time Zone

	int* yr;
	int* mn;
	int* dy;
	int* hr;

	double* wd;
	double* ws;
	double* tp;

	double* dl;		// Daylight ratio (0-1)
	double* sn;		// Short radiation

	int nr_days;
public:
	MetData()
	{
		setIsFile(FileList::fnMetData(FileList::IS, 1));
		setOsFile(FileList::fnMetData(FileList::OS, 1));
		tzn = 9;
	}
	~MetData();
	void setGeoPosition(double  lon_, double  lat_, double  zzz_){lon = lon_; lat = lat_; zzz = zzz_;}
	void getGeoPosition(double& lon_, double& lat_, double& zzz_) const {lon_ = lon; lat_ = lat; zzz_ = zzz;}
	void setTimeZone(int tzn_){tzn = tzn_;}
	int  getTimeZone()  const {return tzn;}
	void setMetData(int  yr_, int  mn_, int  dy_, int  hr_, double  wd_, double  ws_, double  tp_, double  dl_, double  sn_);
	void getMetData(int& yr_, int& mn_, int& dy_, int& hr_, double& wd_, double& ws_, double& tp_, double& dl_, double& sn_) const;
	int  getNoDays() const {return nr_days;}
	virtual void redim(int n);
	virtual void init ();
	virtual void scan ();
	virtual void print();
	virtual void lists();
	virtual void advance();
	virtual void reverse();
};

#endif
