#ifndef SUN_H
#define SUN_H

#include "../share/common.h"
#include "../share/kalendar.h"

class Sun
{
	double lon;
	double lat;

	int yr;
	int mn;
	int dy;
	int hr;

	Kalendar* kal;
protected:
	virtual double dayAngle() const;
	virtual double hourAngle() const;
	virtual double sunLatitude() const {return 23.5*sin(dayAngle())*M_PI/180;}
	virtual double zenith(double phi, double dcl, double hrs) const
	{
		return sin(phi)*sin(dcl) + cos(phi)*cos(dcl)*cos(hrs);
	}
public:
	Sun(double lon_, double lat_){lon = lon_; lat = lat_; kal = new Kalendar();}
	void setDate(int  yr_, int  mn_, int  dy_){yr = yr_; mn = mn_; dy = dy_; kal->setDate(yr_, mn_, dy_);}
	void getDate(int& yr_, int& mn_, int& dy_) const {yr_ = yr; mn_ = mn; dy_ = dy;}
	void setTime(int& hr_){hr = hr_;}
	int  getTime() const  {return hr;}
	void getLatLon(double& lat_, double& lon_) const {lat_ = lat; lon_ = lon;}
	virtual double radiation(double dl) const;

	enum SunPosition {ABOVE, BELOW, HORIZON_DD, HORIZON_DN};
	virtual SunPosition getSunPosition() const;
	virtual SunPosition getSunPosition(double& sr, double& ss) const
	{
		sr = ss = 0.0;
		return getSunPosition();
	}

	virtual ~Sun(){delete kal;}
};

#endif SUN_H
