#ifndef COMMON_H
#define COMMON_H

#define NO_OF_CHARS_PER_ONE_LINE 1024
#define COLUMN 20

#define DEG2RAD  0.017453292519943
#define RAD2DEG  57.29577951308232
#define M_PI     3.141592653589793
#define COSINE_2_PI_DIV_9      0.766044443
#define SQRT_2                 1.414213562

// Use Standard Template Library
#include <iostream>
#include <fstream>
#include <iomanip>
#include <string>
using namespace std;

#include <math.h>

#define max(a,b)    (((a) > (b)) ? (a) : (b))
#define min(a,b)    (((a) < (b)) ? (a) : (b))


#define MAX_WARNING_MESSAGE 10

#define GEOMETRIC_TOL 1.0e-5

#define SCAN_CHECK 0

static int message_counter_ErrorPasquillGifford_szSolve = 0;
static int message_counter_ErrorSimpson                 = 0;
static int message_counter_ErrorTerrainAdjustment_simpl = 0;
static int next_output_progress_percentages             = 0;

extern ofstream CLOG;
extern ofstream CERR;
extern ofstream CLST;
extern ofstream CCSV;
extern bool     JP  ;

extern bool  TRACE_Q;
#define ML_TRACE(c1) if(TRACE_Q){CLOG << c1 << endl;}

extern bool  VALIDATION_Q;

#endif
