#ifndef LINE_SRC_NUM_ITG_SIMULATOR_H
#define LINE_SRC_NUM_ITG_SIMULATOR_H

#include "LineSrcSimulator.h"
#include "NumIntegrator.h"

class LineSrcNumItgSimulator : public LineSrcSimulator
{
	double cosine_for_angle_gived_by_blowing_direction_and_road;
	double length;
	double inf;
	double sup;
	double inf_y;
	double sup_y;
	double inf_puff;
	double sup_puff;
	double dst_puff;
protected:
	NumIntegrator* num_itg;
	virtual void   setLength(double length_){length = length_;}
	virtual double getLength() const {return length;}
	virtual double integrand(double x, bool dirac = false);
	virtual double equation(PlumePuff pp = PLUME);
	virtual int    assembleSimulationProperties(bool new_met, bool new_src);

	virtual void   setInf(double inf_){inf = inf_;}
	virtual double getInf() const {return inf;}
	virtual void   setSup(double sup_){sup = sup_;}
	virtual double getSup() const {return sup;}

	virtual void   setInf_y(double inf_y_){inf_y = inf_y_;}
	virtual double getInf_y() const {return inf_y;}
	virtual void   setSup_y(double sup_y_){sup_y = sup_y_;}
	virtual double getSup_y() const {return sup_y;}

	virtual void   setInfPuff(double inf_puff_){inf_puff = inf_puff_;}
	virtual double getInfPuff() const {return inf_puff;}
	virtual void   setSupPuff(double sup_puff_){sup_puff = sup_puff_;}
	virtual double getSupPuff() const {return sup_puff;}
	virtual void   setDstPuff(double dst_puff_){dst_puff = dst_puff_;}
	virtual double getDstPuff() const {return dst_puff;}

	virtual void   setAngleCosine(double cosine){cosine_for_angle_gived_by_blowing_direction_and_road = cosine;}
	virtual double getAngleCosine() const {return cosine_for_angle_gived_by_blowing_direction_and_road;}

	virtual double wsMltfactor() const;
public:
	LineSrcNumItgSimulator(){setOpenAngle(22.5);}
	virtual ~LineSrcNumItgSimulator(){delete num_itg;}
	virtual void scan ();
	virtual void print();
	virtual void lists();
	virtual void exec (bool new_met, bool new_src);
};

#endif
