#include "LineSrcNumItgSimulatorAnotherIntegrand.h"
#include "NR.h"


double LineSrcNumItgSimulatorAnotherIntegrand::integrand(double x, bool dirac)
{
	ML_TRACE("LineSrcNumItgSimulatorAnotherIntegrand::integrand");

	// Placeholders for coordinates
	double _x_, _y_, _z_, _h_;
	ptr_rcp->getCoor(_x_, _y_, _z_, _h_);

	const double y0 = getInf_y();
	const double y1 = getSup_y();
	const double sy = ptr_sgm->y(x + getVirtual4Latr());
	const double sz = ptr_sgm->z(x + getVirtual4Vert());
	const double fact1 = 0.5*getEmi()/M_PI/sy/sz/getModelled_ws();
	const double fact3 = exp(- 0.5*pow((_z_ - dh())/sz, 2)) + exp(- 0.5*pow((_z_ + dh())/sz, 2));

	if(!dirac)
	{
		const double x0 = getInf();
		const double x1 = getSup();
		const double y  = y0 + (y1 - y0)*(x - x0)/(x1 - x0);
		const double fact2 = exp(- 0.5*pow(y/sy, 2));
		return fact1*fact2*fact3/getAngleCosine();
	}
	else
	{
		const double comp1 = -sqrt(0.5*M_PI)*sy*NR::SpecialFunctions::erff(y0/SQRT_2/sy);
		const double comp2 =  sqrt(0.5*M_PI)*sy*NR::SpecialFunctions::erff(y1/SQRT_2/sy);
		const double fact2 = fabs(comp1 + comp2);
		return fact1*fact2*fact3;
	}
}
