#ifndef METI_LIS_PASQUILL_GIFFORD_H
#define METI_LIS_PASQUILL_GIFFORD_H

#include "PasquillGifford.h"
#include "Blg.h"

class MetiLisPasquillGifford : public PasquillGifford
{
	bool not_validated_wrt_z;
	bool not_validated_wrt_y;

	bool PG_Q;

	// Placeholders for retrieving the building parameters
	double _w1_, _w2_, _hh_, _z1_, _z2_, _y1_, _y2_;

	double sz_sol;
	double sy_sol;
	double y_offset;
	double cy1_coef;
	double cy2_coef;
protected:
	virtual double el() const {return min(_hh_, _w1_);}
	virtual void   resetValidationFlags(){not_validated_wrt_z = not_validated_wrt_y = false;}
public:
	MetiLisPasquillGifford(){}
	void setParameters(double w1_,double w2_,double hh_,double z1_,double z2_,double y1_,double y2_);
	virtual double z(double x);
	virtual double y(double x);
	virtual bool   validated() const {return !(not_validated_wrt_z || not_validated_wrt_y);}

	virtual void scan (){}
	virtual void print() const {}

	virtual ~MetiLisPasquillGifford(){}
};

#endif