#ifndef BLG_H
#define BLG_H

#include "../share/SimpleIterator.h"
#include "../share/FileFactory.h"

class _Blg_
{
	int    pwa;

	int    sq[16];			// Rather redundant but introducing for clarifying ...
	int    wd[16];			// Rather redundant but introducing for clarifying ...

	double w1[16];
	double w2[16];
	double hh[16];
	int    tp[16];
	double he[16];
	double dx[16];
	double dy[16];
	double z1[16];
	double z2[16];
	double y1[16];
	double y2[16];
	double al[16];
	int    ef[16];
public:
	_Blg_(){}
	void virtual setPrincipalWindAxis(int pwa_){pwa = pwa_;}
	int  get_Blg_(double& w1_, double& w2_, double& hh_, int& tp_, double& he_, double& dx_, double& dy_, double& z1_, double& z2_, double& y1_, double& y2_, double& al_, int& ef_) const;
	virtual void scan (ifstream& is);
	virtual void print(ofstream& os);
	virtual void lists();
};

class Blg : public SimpleIterator, public FileManager
{
	_Blg_* blg;

public:
	Blg()
	{
		setIsFile(FileList::fnBlg(FileList::IS, 1));
		setOsFile(FileList::fnBlg(FileList::OS, 1));
	}

	void virtual setPrincipalWindAxis(int pwa){blg->setPrincipalWindAxis(pwa);}
	int  getBlg(double& w1_, double& w2_, double& hh_, int& tp_, double& he_, double& dx_, double& dy_, double& z1_, double& z2_, double& y1_, double& y2_, double& al_, int& ef_) const;
	void virtual scan ();
	void virtual print();
	void virtual lists();
	void virtual redim(int n);
	virtual void advance();
	virtual void reverse();
	virtual ~Blg();
};

#endif