#ifndef DROPLET_H
#define DROPLET_H

#include "../share/SimpleIterator.h"
#include "../share/FileFactory.h"

class Droplet : public SimpleIterator, public FileManager
{
protected:
	double* droplet_inf;
	double* droplet_sup;
public:
	Droplet()
	{
		setIsFile(FileList::fnDroplet(FileList::IS, 1));
		setOsFile(FileList::fnDroplet(FileList::OS, 1));
	}
	virtual double getDiameter() const {return ((*droplet_inf) < 1.0e-5 ? 0.0 : 0.5*((*droplet_inf)+(*droplet_sup)));}
	virtual double getLower()    const {return *droplet_inf;}
	virtual double getUpper()    const {return *droplet_sup;}
	virtual void redim(int n);
	virtual void scan ();
	virtual void print();
	virtual void lists();
	virtual void advance();
	virtual void reverse();
	
	virtual ~Droplet();
};

#endif
