#ifndef SRC_H
#define SRC_H

#include "ring.h"
#include "link.h"
#include "../share/FileFactory.h"
#include "../share/SimpleIterator.h"

class Src : public SimpleIterator, public FileManager
{
	double operation_percent;
	double mol;
public:
	Src()
	{
		setIsFile(FileList::fnMetData(FileList::IS, 1));
		setOsFile(FileList::fnMetData(FileList::OS, 1));
		operation_percent = -1.0;
	}

	virtual void   setOperationPercent(double operation_percent_){operation_percent = operation_percent_;}
	virtual double getOperationPercent() const {return operation_percent;}

	virtual double getPointSrc(Ring& rin_, bool& _stk_, bool& _plm_, double& emi_, double& vel_, double& gas_, double& tpr_) const
	{
		return operation_percent;
	}

	virtual double getLineSrc(Link& lnk_, double& emi_) const
	{
		return operation_percent;
	}

	virtual void   getMediumProperties(double& drg_) const {drg_ = 0.0;}
	virtual double getBulkDensity(int i) const {return 0;}
	virtual double getWeightRatio(int i) const {return 0;}
	virtual void   setMolecularWeight(double mol_) {mol = mol_;}
	virtual double getMolecularWeight() const {return mol;}

	virtual void redim(int /* n */){}
	virtual void scan (){}
	virtual void print(){}
	virtual void lists(){}
	virtual void advance(){}
	virtual void reverse(){}

	virtual ~Src(){}
};

#endif
